// DlgEditFixtureList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgEditFixtureList.h"
#include ".\dlgeditfixturelist.h"


// CDlgEditFixtureList ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgEditFixtureList, CDialog)
CDlgEditFixtureList::CDlgEditFixtureList(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEditFixtureList::IDD, pParent)
{
}

CDlgEditFixtureList::~CDlgEditFixtureList()
{
}

void CDlgEditFixtureList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_EFL_FIXTURELIST, m_List_EflFixtureList);
}


BEGIN_MESSAGE_MAP(CDlgEditFixtureList, CDialog)
	ON_BN_CLICKED(IDC_BTN_EFL_MODIFY, OnBnClickedBtnEflModify)
	ON_BN_CLICKED(IDC_BTN_EFL_DELETE, OnBnClickedBtnEflDelete)
	ON_BN_CLICKED(IDC_BTN_EFL_ADDRECTANGLE, OnBnClickedBtnEflAddrectangle)
	ON_BN_CLICKED(IDC_BTN_EFL_ADDLINE, OnBnClickedBtnEflAddline)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_LBN_SELCHANGE(IDC_LIST_EFL_FIXTURELIST, OnLbnSelchangeListEflFixturelist)
END_MESSAGE_MAP()


// CDlgEditFixtureList ޽ óԴϴ.

CString CDlgEditFixtureList::GetListBoxText()
{
	CString str = "";

	int idx = m_List_EflFixtureList.GetCurSel();
	if(idx < 0) return str;

	m_List_EflFixtureList.GetText(idx, str);

	return str;
}

// lpSymbolBase   ´.
lpSymbolBase CDlgEditFixtureList::GetSymbol()
{
	CString str = GetListBoxText();
	lpSymbolBase pSymbolBase = SymbolArray::GetInstance().FindSymbol(str.GetBuffer(str.GetLength()));

#ifdef DEBUG
	if(!pSymbolBase) 
		return NULL;
#endif //

	return pSymbolBase;
}

BOOL CDlgEditFixtureList::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Ʈ ڽ  ߰ մϴ.
	UpdateFixtureList();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

// Ʈ ڽ  ߰ մϴ.
void CDlgEditFixtureList::UpdateFixtureList()
{
	// Ʈ  äϴ.
	SymbolArray::GetInstance().SymbolInfoUpdate(&m_List_EflFixtureList);

	//  Ʒ ߰Ѵ.
	m_List_EflFixtureList.AddString("--------");
}

void CDlgEditFixtureList::OnBnClickedBtnEflModify()
{
	// ش Symbol մϴ.
	lpSymbolBase pSymbol = GetSymbol();
	if(!pSymbol) return;

	if(pSymbol->type == SYMBOL_LINE) {
		lpSymbolLine psymbolline = (lpSymbolLine)pSymbol;

		//  Symbol ߰մϴ.

		// ̾α׸ ٿ.
		CDlgLinearFixtureSetup dlg;

		dlg.name = psymbolline->name.c_str();
		dlg.pixels = psymbolline->totalPixels;
		dlg.symbollength = psymbolline->length;
		dlg.modifymode = CDlgLinearFixtureSetup::LINEARMODE_MODIFY;	//   ȯѴ.

		if(dlg.DoModal() == IDOK) {
			//  ͼ Ѵ.
			psymbolline->name = dlg.name.GetBuffer(dlg.name.GetLength());
			psymbolline->totalPixels = dlg.pixels;
			psymbolline->length = dlg.symbollength;

			//  ٲ Ǹ ⼭ ȭ ü Ʈ ؾ  ̴.
			g_PixelMapView->Invalidate();
		}
	} else {
		lpSymbolRectangle psymbolRect = (lpSymbolRectangle )pSymbol;

		// 簢 Symbol ߰մϴ.

		// ̾α׸ ٿ.
		CDlgRectFixtureSetup dlg;

		dlg.name = psymbolRect->name.c_str();
		dlg.horipixels = psymbolRect->horizontalPixels;
		dlg.vertpixels = psymbolRect->verticalPixels;
		dlg.symbolwidth = psymbolRect->symbolWidth;
		dlg.symbolheight = psymbolRect->symbolHeight;
		dlg.totalpixels = psymbolRect->totalPixels;
		dlg.totalwidth = psymbolRect->totalWidth;
		dlg.totalheight = psymbolRect->totalHeight;
		dlg.color = psymbolRect->color;
		dlg.scanorder = psymbolRect->scanOrder;
		dlg.modifymode = CDlgRectFixtureSetup::RECTANGLEMODE_MODIFY;	//   ȯѴ.

		if(dlg.DoModal() == IDOK) {
			//  ͼ Ѵ.
			psymbolRect->name = dlg.name.GetBuffer(dlg.name.GetLength());
			psymbolRect->horizontalPixels = dlg.horipixels;
			psymbolRect->verticalPixels = dlg.vertpixels;
			psymbolRect->symbolWidth = dlg.symbolwidth;
			psymbolRect->symbolHeight = dlg.symbolheight;
			psymbolRect->totalPixels = dlg.totalpixels;
			psymbolRect->totalWidth = dlg.totalwidth;
			psymbolRect->totalHeight = dlg.totalheight;
			psymbolRect->color = dlg.color;
			psymbolRect->scanOrder = dlg.scanorder;

			//  ٲ Ǹ ⼭ ȭ ü Ʈ ؾ  ̴.
			g_PixelMapView->Invalidate();
		}
	}
}

void CDlgEditFixtureList::OnBnClickedBtnEflDelete()
{
	// ش Symbol մϴ.
	lpSymbolBase pSymbol = GetSymbol();
	if(!pSymbol) return;

	if(pSymbol->defaultSymbol == true) {
		// ⺻ ɺ̸ ȭ ڸ  ϰ  ϸ ȵȴ.
		MessageBox("⺻ ɺ  ȵ˴ϴ.", "");
		return;
	}
}

void CDlgEditFixtureList::OnBnClickedBtnEflAddrectangle()
{
	// ̾α׸ ٿ.
	CDlgRectFixtureSetup dlg;
	if(dlg.DoModal() == IDOK) {
		lpSymbolRectangle psRect;
		psRect = new SymbolRectangle(dlg.name.GetBuffer(dlg.name.GetLength()), 
			dlg.horipixels, dlg.vertpixels, dlg.scanorder, RGB(255, 0, 0), false);
		SymbolArray::GetInstance().AddSymbol((lpSymbolBase)psRect);

		// ü ߰Ŀ Edit Fixture List ȭ Ʈ Ѵ.
		UpdateFixtureList();
	}
}

void CDlgEditFixtureList::OnBnClickedBtnEflAddline()
{
	// ̾α׸ ٿ.
	CDlgLinearFixtureSetup dlg;
	if(dlg.DoModal() == IDOK) {
		lpSymbolLine psline;
		psline = new SymbolLine(dlg.name.GetBuffer(dlg.name.GetLength()), dlg.pixels, RGB(255, 0, 0), false);
		SymbolArray::GetInstance().AddSymbol((lpSymbolBase)psline);

		// ü ߰Ŀ Edit Fixture List ȭ Ʈ Ѵ.
		UpdateFixtureList();
	}
}

void CDlgEditFixtureList::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnOK();
}

void CDlgEditFixtureList::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnCancel();
}

void CDlgEditFixtureList::OnLbnSelchangeListEflFixturelist()
{
	// Ʈ  Ǹ ⼭ Ʈ
}

