#include "StdAfx.h"
#include ".\fixturearray.h"

FixtureArray::FixtureArray(void)
{
	m_vFixtureElementList.clear();

	m_RefUid = 0;
}

FixtureArray::~FixtureArray(void)
{
	DeleteAllFixture();
}

// ߰
void FixtureArray::AddFixture(int xIndex, int yIndex)
{
	lpFixtureElement pFix = new FixtureElement();

	pFix->uid = m_RefUid++;
	pFix->x = xIndex;
	pFix->y = yIndex;

	//  Ǿ ־ մϴ.
	lpSymbolBase psymbol = SymbolArray::GetInstance().GetSymbol();
	ASSERT(psymbol);
	pFix->symbolUid = (psymbol == NULL) ? -1 : psymbol->uid;	// ɺ uid ԷѴ.

	AddFixture(pFix);
}

void FixtureArray::AddFixture(lpFixtureElement pFixture)
{
	ASSERT(pFixture);

	m_vFixtureElementList.push_back(pFixture);

	// FixtureElement  ش.
	ChangedFixtureElement(pFixture);

	//  ٲ  ̾α   Ʈ ش.
	UpdatePixelMapInfo();
}

// Ž
bool FixtureArray::FindFixture(int xIndex, int yIndex)
{
	lpFixtureElement pF;
	for(vFixtureElementIter iter = m_vFixtureElementList.begin(); iter != m_vFixtureElementList.end(); ++iter) {
		pF = (lpFixtureElement)(*iter);
		ASSERT(pF);

//		if(pF->x == xIndex && pF->y == yIndex) {
			if(SymbolArray::GetInstance().FindSymbolEx(pF->symbolUid, 
				CPoint(pF->x, pF->y), xIndex, yIndex)) {
					m_pcurFixtureElement = pF;
					return true;
				}
//		}
	}	

	return false;
}

// ٸ  FuxtureElement     ȣѴ.
void FixtureArray::ChangedFixtureElement(lpFixtureElement pFixEle)
{
	// ߰ Fixture õȰͰ .
	m_pcurFixtureElement = pFixEle;
}

// Current Selected ChangeFixtureElement
void FixtureArray::UpdatePixelMapInfo()
{
	//  õ Fixture Element Ǿ  ̾α ʿ  ǥϱ ؼ
	//  Ѱ ش.

	// FixturePage Ȱȭ Ǿ  
	if(g_DlgFixturePage && g_DlgFixturePage->m_hWnd && g_DlgFixturePage->IsWindowVisible() && m_pcurFixtureElement) {
		g_DlgFixturePage->m_FixturePortAndSequence.Empty();
		g_DlgFixturePage->m_FixturePortAndSequence.Format("A%d", m_pcurFixtureElement->uid);
		g_DlgFixturePage->m_FixtureOriginX = m_pcurFixtureElement->x;
		g_DlgFixturePage->m_FixtureOriginY = m_pcurFixtureElement->y;

		//   ɺ ü ֱ  ⼭ ȣش.
		SymbolArray::GetInstance().CurChangeFixtureInfo(m_pcurFixtureElement->symbolUid, g_DlgFixturePage);
		// ɺ ü ȼ Ʈ  Ʈ ڽ ʿ Ѵ.
		g_DlgFixturePage->m_FixtureFixturePixelsList.ResetContent();
		SymbolArray::GetInstance().PutSelectedPixelsList(m_pcurFixtureElement->symbolUid, 
													CPoint(m_pcurFixtureElement->x, m_pcurFixtureElement->y),
													&g_DlgFixturePage->m_FixtureFixturePixelsList);

		g_DlgFixturePage->UpdateData(FALSE);
	} else

	// Sequence Ȱȭ Ǿ  
	if(g_DlgSequencePage && g_DlgSequencePage->m_hWnd && g_DlgSequencePage->IsWindowVisible() && m_pcurFixtureElement) {
		g_DlgSequencePage->DeleteAll();

		int totalAddressCount = 0;
		CString portStr;
		lpFixtureElement pF;
		for(vFixtureElementIter iter = m_vFixtureElementList.begin(); iter != m_vFixtureElementList.end(); ++iter) {
			pF = (lpFixtureElement)(*iter);
			ASSERT(pF);

			portStr.Empty();
			portStr.Format("A%d", pF->uid);

			// Fixture ɺ      ޾ƾ Ѵ.
			int curSymbolTotalPixels = SymbolArray::GetInstance().GetSymbolTotalPixels(pF->symbolUid);
			ASSERT(curSymbolTotalPixels != -1);
			totalAddressCount += curSymbolTotalPixels;

			g_DlgSequencePage->AddData(portStr, totalAddressCount, pF);
		}	
	} else

	// PixelList Ȱȭ Ǿ  
	if(g_DlgPixelListPage && g_DlgPixelListPage->m_hWnd && g_DlgPixelListPage->IsWindowVisible() && m_pcurFixtureElement) {

		g_DlgPixelListPage->DeleteAll();

		lpFixtureElement pF;
		for(vFixtureElementIter iter = m_vFixtureElementList.begin(); iter != m_vFixtureElementList.end(); ++iter) {
			pF = (lpFixtureElement)(*iter);
			ASSERT(pF);

			// ɺ ü ȼ Ʈ  Ʈ ڽ ʿ Ѵ.
			g_DlgFixturePage->m_FixtureFixturePixelsList.ResetContent();
			SymbolArray::GetInstance().PutSelectedPixelsList(m_pcurFixtureElement->symbolUid, 
				CPoint(m_pcurFixtureElement->x, m_pcurFixtureElement->y),
				&g_DlgPixelListPage->m_PixelListList);
		}	
	}
}

// 
bool FixtureArray::DeleteFixture(lpFixtureElement pFixture)
{
	lpFixtureElement pF;
	for(vFixtureElementIter iter = m_vFixtureElementList.begin(); iter != m_vFixtureElementList.end(); ++iter) {
		pF = (lpFixtureElement)(*iter);
		ASSERT(pF);

		//  .
		if(pF == pFixture) {
			delete pF;
			m_vFixtureElementList.erase(iter);
			return true;
		}
	}	

	return false;
}

void FixtureArray::DeleteAllFixture()
{
	//  
	for_each(m_vFixtureElementList.begin(), m_vFixtureElementList.end(), DeleteObj());
}

// (ߺüũ)
bool FixtureArray::IsOverapFixture(int xindex, int yindex)
{
	// x, y ǥ  ͼ Fixture üũ ϰ ش  õǸ true Ѵ.
	// õǸ m_pcurFixtureElement  ũ Ų.

	return true;
}

// õ FixtureElement
lpFixtureElement FixtureArray::GetFixtureElement()
{
	return m_pcurFixtureElement;
}

// Draw
void FixtureArray::Draw(CDC* pDC)
{
	CPen     *oldPen;
	CBrush brush, *oldbrush;
	brush.CreateSolidBrush(COLOR_CELL_TYPE0);
	CPen newPen(PS_SOLID, 1, RGB(255, 0, 0)); // 0 width = 1 device unit
	oldbrush = pDC->SelectObject(&brush);
	oldPen = pDC->SelectObject(&newPen);

//	int left, top;
	CPoint newPoint;
	lpFixtureElement pF;
	for(vFixtureElementIter iter = m_vFixtureElementList.begin(); iter != m_vFixtureElementList.end(); ++iter) {
		pF = (lpFixtureElement)(*iter);
		ASSERT(pF);
		ASSERT(pF->symbolUid != -1);

		newPoint = CPoint(pF->x * PIXEL_PER_SIZE, pF->y * PIXEL_PER_SIZE);

		bool bSelected = (m_pcurFixtureElement == pF) ? true : false;
		SymbolArray::GetInstance().DrawSymbol(pDC, newPoint, pF->symbolUid, bSelected);

// 		//簢 ׸.
// 		CRect rect = CRect(left, top, left + PIXEL_PER_SIZE, top + PIXEL_PER_SIZE);
// 		pDC->FillRect(rect, &brush);
// 
// 		// õ Fixture ׵θ ĥѴ.
// 		if(m_pcurFixtureElement == pF)
// 			pDC->Rectangle(&rect);
	}	

	pDC->SelectObject(oldbrush);
	pDC->SelectObject(oldPen);
}


// õ Fixture oriX  ̵Ų.
bool FixtureArray::CurChangeFixturePosX(bool bup)
{
	lpFixtureElement pFix = GetFixtureElement();
	if(pFix == NULL)
		return false;

	if(bup)
		pFix->x += 1;
	else
		pFix->x -= 1;

	// PixelMap View ȭ Ʈ Ѵ.
	g_PixelMapView->Invalidate();
	// Ʈ ȭ Ʈ Ѵ.
	UpdatePixelMapInfo();

	return true;
}

// õ Fixture oriY  ̵Ų.
bool FixtureArray::CurChangeFixturePosY(bool bup)
{
	lpFixtureElement pFix = GetFixtureElement();
	if(pFix == NULL)
		return false;

	if(bup)
		pFix->y += 1;
	else
		pFix->y -= 1;

	// PixelMap View ȭ Ʈ Ѵ.
	g_PixelMapView->Invalidate();
	// Ʈ ȭ Ʈ Ѵ.
	UpdatePixelMapInfo();

	return true;
}