#include "StdAfx.h"
#include ".\symbolarray.h"

SymbolArray::SymbolArray(void)
{
	m_vSymbolList.clear();

	m_RefUid = 0;

	m_pcurSymbolBase = NULL;

	// ʱ ü ʱȭ - ׽Ʈ
	Init();
}

SymbolArray::~SymbolArray(void)
{
	DeleteAllSymbol();
}

// Init
// ⺻  εѴ.
void SymbolArray::Init()
{
	// ⺻ ɺ ü εѴ.

	// line ׽Ʈ ɺ ü ߰
	lpSymbolLine psline;

	psline = new SymbolLine("line1x5", 5, RGB(255, 0, 0));
	AddSymbol((lpSymbolBase)psline);

	psline = new SymbolLine("line1x8", 8, RGB(255, 255, 0));
	AddSymbol((lpSymbolBase)psline);

	psline = new SymbolLine("line1x10", 10, RGB(255, 0, 255));
	AddSymbol((lpSymbolBase)psline);

	m_pcurSymbolBase = psline;

	// rectangle ׽Ʈ ɺ ü ߰
	lpSymbolRectangle psRect;

	psRect = new SymbolRectangle("rect5x5", 5, 5, 0, RGB(255, 0, 0));
	AddSymbol((lpSymbolBase)psRect);
}

// Load
// Symbol Data εѴ.
void SymbolArray::Load()
{
	//   ɺ ü εѴ.
}

// ߰
void SymbolArray::AddSymbol(lpSymbolBase pSymbolBase)
{
	ASSERT(pSymbolBase);

	pSymbolBase->uid = m_RefUid++;

	m_vSymbolList.push_back(pSymbolBase);
}

// 
bool SymbolArray::DeleteSymbol(lpSymbolBase pSymbolBase)
{
	lpSymbolBase pSB;
	for(vSymbolBaseIter iter = m_vSymbolList.begin(); iter != m_vSymbolList.end(); ++iter) {
		pSB = (lpSymbolBase)(*iter);
		ASSERT(pSB);

		//  .
		if(pSB == pSymbolBase) {
			delete pSB;
			m_vSymbolList.erase(iter);
			return true;
		}
	}	

	return false;
}

void SymbolArray::DeleteAllSymbol()
{
	//  
	for_each(m_vSymbolList.begin(), m_vSymbolList.end(), DeleteObj());
}

// ش ɺ 
lpSymbolBase SymbolArray::GetSymbol()
{
	return m_pcurSymbolBase;
}

// ش uid ´ ɺ ã
lpSymbolBase SymbolArray::FindSymbol(int symbolUid)
{
	lpSymbolBase pSB;
	for(vSymbolBaseIter iter = m_vSymbolList.begin(); iter != m_vSymbolList.end(); ++iter) {
		pSB = (lpSymbolBase)(*iter);
		ASSERT(pSB);

		if(pSB->uid == symbolUid)
			return pSB;
	}
	return NULL;
}

lpSymbolBase SymbolArray::FindSymbol(string symbolname)
{
	lpSymbolBase pSB;
	for(vSymbolBaseIter iter = m_vSymbolList.begin(); iter != m_vSymbolList.end(); ++iter) {
		pSB = (lpSymbolBase)(*iter);
		ASSERT(pSB);

		if((pSB->name.compare(symbolname) == 0))
			return pSB;
	}
	return NULL;
}

// Draw
void SymbolArray::DrawSymbol(CDC* pDC, CPoint& point, int& symbolUid, bool& bSelected)
{
	// ش ɺ о 
	lpSymbolBase psymbol = FindSymbol(symbolUid);
	// ش ɺ ͸ ؼ  ϱ
	if(psymbol->type == SYMBOL_LINE) {
		DrawSymbolLine(pDC, point, bSelected, psymbol);
	} else {	// SYMBOL_RECTANGLE
		DrawSymbolRectangle(pDC, point, bSelected, psymbol);
	}
}

// Draw : Line
void SymbolArray::DrawSymbolLine(CDC* pDC, CPoint& point, bool& bSelected, lpSymbolBase psymbol)
{
	lpSymbolLine psymbolline = (lpSymbolLine)psymbol;

	//簢 ׸.
	CRect rect = CRect(point.x, point.y, point.x + PIXEL_PER_SIZE, point.y + PIXEL_PER_SIZE);

	//ɺ  ŭ Ѵ.
	int newlength = (psymbolline->length == 0) ? 0 : psymbolline->length-1;
	rect.right += (newlength * PIXEL_PER_SIZE);

	CBrush brush, *pbrush;
	brush.CreateSolidBrush(psymbolline->color);
	pbrush = pDC->SelectObject(&brush);

	// 簢 ׸.
	pDC->FillRect(rect, pDC->GetCurrentBrush());

	pDC->SelectObject(pbrush);

	// õ Fixture ׵θ ĥѴ.
	if(bSelected)
		pDC->Rectangle(&rect);
}

// Draw : Rectangle
void SymbolArray::DrawSymbolRectangle(CDC* pDC, CPoint& point, bool& bSelected, lpSymbolBase psymbol)
{
	lpSymbolRectangle psymbolrect = (lpSymbolRectangle)psymbol;

	//簢 ׸.
	CRect rect = CRect(point.x, point.y, point.x + PIXEL_PER_SIZE, point.y + PIXEL_PER_SIZE);

	// ɺ ũ ŭ Ѵ.
	int newwidth = (psymbolrect->symbolWidth == 0) ? 0 : psymbolrect->symbolWidth-1;
	int newheight = (psymbolrect->symbolHeight == 0) ? 0 : psymbolrect->symbolHeight-1;
	rect.right += (newwidth* PIXEL_PER_SIZE);
	rect.bottom += (newheight* PIXEL_PER_SIZE);

	CBrush brush, *pbrush;
	brush.CreateSolidBrush(psymbolrect->color);
	pbrush = pDC->SelectObject(&brush);

	// 簢 ׸.
	pDC->FillRect(rect, pDC->GetCurrentBrush());

	pDC->SelectObject(pbrush);

	// õ Fixture ׵θ ĥѴ.
	if(bSelected)
		pDC->Rectangle(&rect);
}

void SymbolArray::DrawMoveEffect(CDC &dc, CPoint& point)
{
	//  õ ɺ  ؼ Ʒ  ٸ ׷  ̴.
	// m_pcurSymbolBase   Ȱؾ Ѵ.

	ASSERT(m_pcurSymbolBase);

	CPen pen;
	// Save the device context
	dc.SaveDC();
//	if (xor) 
	{ 
		dc.SetROP2(R2_NOTXORPEN);
		pen.CreatePen(PS_SOLID,  1, RGB(0, 0, 0)); // 0 width = 1 device unit
	} 
//	else 
//	{
//		pen.CreatePen(PS_SOLID, 0, RGB(0, 0, 0)); // 0 width = 1 device unit
//	}

	//簢  Ŀ ɺ  ͼ ش.
	CRect rect = CRect(point.x, point.y, point.x + PIXEL_PER_SIZE, point.y + PIXEL_PER_SIZE);
	if(m_pcurSymbolBase->type == SYMBOL_LINE) {
		lpSymbolLine psymbolline = (lpSymbolLine)m_pcurSymbolBase;

		int newlength = (psymbolline->length == 0) ? 0 : psymbolline->length-1;
		rect.right += (newlength * PIXEL_PER_SIZE);
	} else {
		lpSymbolRectangle psymbolrect = (lpSymbolRectangle)m_pcurSymbolBase;

		int newwidth = (psymbolrect->symbolWidth == 0) ? 0 : psymbolrect->symbolWidth-1;
		int newheight = (psymbolrect->symbolHeight == 0) ? 0 : psymbolrect->symbolHeight-1;
		rect.right += (newwidth* PIXEL_PER_SIZE);
		rect.bottom += (newheight* PIXEL_PER_SIZE);
	}

	dc.SelectObject(&pen);
	// Draw the rect with lines (eliminate rect middle fill)
//	dc.SetBkColor(m_pcurSymbolBase->color);
	dc.Rectangle(rect);
	// Clean up
	dc.RestoreDC(-1);
}

// ɺ ޺ ڽ  Ʈ
void SymbolArray::SymbolInfoUpdate(CComboBox* pComboBox)
{
	// 
	pComboBox->ResetContent();

	lpSymbolBase pSB;
	for(vSymbolBaseIter iter = m_vSymbolList.begin(); iter != m_vSymbolList.end(); ++iter) {
		pSB = (lpSymbolBase)(*iter);
		ASSERT(pSB);

		//Ʈ  ߰
		pComboBox->AddString(pSB->name.c_str());
	}
}

// ɺ ޺ ڽ  Ʈ
void SymbolArray::SymbolInfoUpdate(CListBox* pListBox)
{
	// 
	pListBox->ResetContent();

	lpSymbolBase pSB;
	for(vSymbolBaseIter iter = m_vSymbolList.begin(); iter != m_vSymbolList.end(); ++iter) {
		pSB = (lpSymbolBase)(*iter);
		ASSERT(pSB);

		//Ʈ  ߰
		pListBox->AddString(pSB->name.c_str());
	}
}

// ɺ ޺ ڽ  Ǹ ɺ  ȴ.
void SymbolArray::CurChangeSymbolInfo(string symbolname)
{
	lpSymbolBase psymbol = FindSymbol(symbolname);
	ASSERT(psymbol);

	// 
	m_pcurSymbolBase = psymbol;
}

//   Fixture  ٲ Dialog    ϱ 
// Fixture ʿ  Լ ȣϰ ȴ.
void SymbolArray::CurChangeFixtureInfo(int symbolUid, CDlgFixturePage* pFixturePage)
{
	// ش ɺ о 
	lpSymbolBase psymbol = FindSymbol(symbolUid);
	ASSERT(psymbol);
	// ش ɺ ͸ ؼ  ä.

	//
	pFixturePage->m_FixtureType = psymbol->name.c_str();
	pFixturePage->m_FixtureTotalPixels = psymbol->totalPixels;
	pFixturePage->m_FixtureLength = psymbol->length;

	if(psymbol->type == SYMBOL_LINE) {
		lpSymbolLine psymbolline = (lpSymbolLine)m_pcurSymbolBase;
		pFixturePage->m_FixtureHorizontalPixels = psymbolline->length;
		pFixturePage->m_FixtureVerticalPixels = 1;
	} else {	// SYMBOL_RECTANGLE
		lpSymbolRectangle psymbolrect = (lpSymbolRectangle)m_pcurSymbolBase;
		pFixturePage->m_FixtureHorizontalPixels = psymbolrect->horizontalPixels;
		pFixturePage->m_FixtureVerticalPixels = psymbolrect->verticalPixels;
		pFixturePage->m_FixtureSymbolWidth = psymbolrect->symbolWidth;
		pFixturePage->m_FixtureSymbolHeight = psymbolrect->symbolHeight;
	}
}

// ش ġ symbol ȼ Ʈ Ͻ ش.
void SymbolArray::PutSelectedPixelsList(int symbolUid, CPoint& point, CListBox* pList)
{
	CString tmpPixels;

	// ش ɺ о 
	lpSymbolBase psymbol = FindSymbol(symbolUid);
	ASSERT(psymbol);

//	//  ٽ Է
//	pList->ResetContent();

	// ش ɺ ͸ ؼ   ä.
	if(psymbol->type == SYMBOL_LINE) {
		lpSymbolLine psymbolline = (lpSymbolLine)m_pcurSymbolBase;

		//  ̶  Ѵ.
		//  ġ ƴϱ.  ŭ for 鼭 ׳ ԷѴ.
		int x = point.x;
		for(int i = 0; i < psymbolline->length; i++) {
			tmpPixels.Empty();
 			tmpPixels.Format("%d, %d", x, point.y);
 
			pList->AddString(tmpPixels);

			x++;
		}
	} else {	// SYMBOL_RECTANGLE
		lpSymbolRectangle psymbolrect = (lpSymbolRectangle)m_pcurSymbolBase;

		int x = point.x;
		int y = point.y;

		//  ĵ  뿡  ȼ 迭  Ʋ.
		if(psymbolrect->scanOrder == 0)	{	//   ϴ  ó
			for(int i = 0; i < psymbolrect->symbolHeight; i++) {
				for(int j = 0; j < psymbolrect->symbolWidth; j++) {

					tmpPixels.Empty();
					tmpPixels.Format("%d, %d", x, y);

					pList->AddString(tmpPixels);

					x++;
				}
				x = point.x;
				y++;
			}
		}
	}
}

// symbolUid ɺ    Ѵ. (ٸ -1() Ѵ.)
int SymbolArray::GetSymbolTotalPixels(int symbolUid)
{
	// ش ɺ о 
	lpSymbolBase psymbol = FindSymbol(symbolUid);
	ASSERT(psymbol);

	return psymbol->totalPixels;
}

// Ž
bool SymbolArray::FindSymbolEx(int symbolUid, CPoint& point, int xIndex, int yIndex)
{
	// ش ɺ о 
	lpSymbolBase psymbol = FindSymbol(symbolUid);
	if(psymbol == NULL) return false;

	// ش ɺ ͸ ؼ   ä.
	if(psymbol->type == SYMBOL_LINE) {
		lpSymbolLine psymbolline = (lpSymbolLine)m_pcurSymbolBase;

		int x = point.x;
		for(int i = 0; i < psymbolline->length; i++) {
			if(x == xIndex && point.y == yIndex)
				return true;

			x++;
		}
	} else {	// SYMBOL_RECTANGLE
		lpSymbolRectangle psymbolrect = (lpSymbolRectangle)m_pcurSymbolBase;

		int x = point.x;
		int y = point.y;
		for(int i = 0; i < psymbolrect->symbolHeight; i++) {
			for(int j = 0; j < psymbolrect->symbolWidth; j++) {

				if(x == xIndex && y == yIndex)
					return true;

				x++;
			}

			x = point.x;
			y++;
		}
	}

	return false;
}

// ⺻  ɺ üũ Ѵ.
// ⺻ ɺ̸  ȴ.
bool SymbolArray::GetDefaultSymbol(string symbolname)
{
	lpSymbolBase pSym = FindSymbol(symbolname);
	ASSERT(pSym);

	return pSym->defaultSymbol;
}