#pragma once

/************************************************************************
* ɺ ⺻                                                  
Type :  Rectangle, Line ΰ  Ѵ.
Ʒ ǥ  ΰ Ӽ ԵǴ  ְ,
Ե ʴ  ִ.
---------------------------------------
                   Rectangle | Line
---------------------------------------
Name					*		*
uid						*		*
Type					*		*
Horizontal Pixels		*
Vertical Pixels			*
Symbol Width			*
Symbol Height			*
Scan Order				*
Total Pixels			*		*
Total Width				*
Total Height			*
Length					*		*
Color					*		*
defaultSymbol			*		*
--------------------------------------

************************************************************************/

enum SYMBOLTYPE { SYMBOL_NONE, SYMBOL_LINE, SYMBOL_RECTANGLE };

//////////////////////////////////////////////////////////////////////////
// SymbolBase
/*
* ɺ ⺻ 
*  uid, type ڵ ԷµǱ  ٸ ͸ ó Ѵ.
*/
class SymbolBase
{
public:
	SymbolBase() {
		name = "";
		uid = 0;
		type = SYMBOL_NONE;
		defaultSymbol = true;
	}
	virtual ~SymbolBase() {}

	//
	string			name;
	int				uid;
	SYMBOLTYPE		type;

	int				totalPixels;

	int				length;
	DWORD			color;

	bool			defaultSymbol;	// ⺻ ɺ    Ǳ  ߰  [12/2/2007 պ]
};
typedef SymbolBase*				lpSymbolBase;
typedef SymbolBase&				refSymbolBase;
typedef vector<lpSymbolBase>	vSymbolBase;
typedef vSymbolBase::iterator	vSymbolBaseIter;

//////////////////////////////////////////////////////////////////////////
// SymbolLine
/*
* ɺ 
* ⺻  ϸ鼭 ׳  Ӽ .
* totalpixels length  ¥    .
*/
class SymbolLine : public SymbolBase
{
public:
	SymbolLine(string _name, int _length, DWORD _color, bool bdefaultsym = true) {
		type = SYMBOL_LINE;

		name = _name;
		length = _length;
		color = _color;
		totalPixels = length;

		defaultSymbol = bdefaultsym;
	}
	virtual ~SymbolLine() {}

	//
};
typedef SymbolLine*				lpSymbolLine;
typedef SymbolLine&				refSymbolLine;

//////////////////////////////////////////////////////////////////////////
// SymbolRectangle
/*
* ɺ 簢
* 簢    ִ.
* symbolWidth, totalWidth  ̴.
* symbolHeight, totalHeight  ̴.
*/
class SymbolRectangle : public SymbolBase
{
public:
	SymbolRectangle(string _name, int _width, int _height, int _scanorder, DWORD _color, bool bdefaultsym = true) {
		type = SYMBOL_RECTANGLE;

		name = _name;
		horizontalPixels = _width;
		totalWidth = _width;
		verticalPixels = _height;
		totalHeight = _height;
		scanOrder = _scanorder;
		color = _color;

		symbolWidth = _width;
		symbolHeight = _height;

		totalPixels = totalWidth * totalHeight;

		defaultSymbol = bdefaultsym;
	}
	virtual ~SymbolRectangle() {}

	//
	int		horizontalPixels;
	int		verticalPixels;

	int		symbolWidth;
	int		symbolHeight;

	int		scanOrder;

	int		totalWidth;
	int		totalHeight;
};
typedef SymbolRectangle*				lpSymbolRectangle;
typedef SymbolRectangle&				refSymbolRectangle;

/************************************************************************/
/* ɺ  ϰ ִ                                      */
/************************************************************************/
class SymbolArray
{
	SymbolArray(void);
public:
	static SymbolArray& GetInstance()
	{
		static SymbolArray sym;
		return sym;
	}
	~SymbolArray(void);

	// Init
	// ⺻  εѴ.
	void Init();
	
	// Load
	// Symbol Data εѴ.
	void Load();

	// ߰
	void AddSymbol(lpSymbolBase pSymbolBase);

	// Ž
	bool FindSymbolEx(int symbolUid, CPoint& point, int xIndex, int yIndex);

	// 
	bool DeleteSymbol(lpSymbolBase pSymbolBase);
	void DeleteAllSymbol();

	// ش ɺ 
	lpSymbolBase GetSymbol();

	// Draw
	// dc :  dc 
	// point :  ȭ ǥ(׸ ǥ ƴ)
	// symbolType : ɺ Ÿ
	void DrawSymbol(CDC* pDC, CPoint& point, int& symbolUid, bool& bSelected);		// Fixture   ؼ  Ҷ
	void DrawMoveEffect(CDC &dc, CPoint& point);		// 콺 ó  Ʈ ó  

	// ɺ ޺ ڽ  Ʈ
	void SymbolInfoUpdate(CComboBox* pComboBox);
	void SymbolInfoUpdate(CListBox* pListBox);
	// ɺ ޺ ڽ  Ǹ ɺ  ȴ.
	void CurChangeSymbolInfo(string symbolname);
	//   Fixture  ٲ Dialog    ϱ 
	// Fixture ʿ  Լ ȣϰ ȴ.
	void CurChangeFixtureInfo(int symbolUid, CDlgFixturePage* pFixturePage);
	// ش ġ symbol ȼ Ʈ Ͻ ش.
	void PutSelectedPixelsList(int symbolUid, CPoint& point, CListBox* pList);
	// symbolUid ɺ    Ѵ. (ٸ -1() Ѵ.)
	int GetSymbolTotalPixels(int symbolUid);

	// ش uid ´ ɺ ã
	lpSymbolBase FindSymbol(int symbolUid);
	lpSymbolBase FindSymbol(string symbolname);

	// ⺻  ɺ üũ Ѵ.
	// ⺻ ɺ̸  ȴ.
	bool GetDefaultSymbol(string symbolname);

protected:

	// Draw : Line
	void DrawSymbolLine(CDC* pDC, CPoint& point, bool& bSelected, lpSymbolBase psymbol);
	// Draw : Rectangle
	void DrawSymbolRectangle(CDC* pDC, CPoint& point, bool& bSelected, lpSymbolBase psymbol);

private:
	vSymbolBase			m_vSymbolList;

	// UID ο   -  
	int					m_RefUid;

	//  õ ɺ 
	lpSymbolBase		m_pcurSymbolBase;
};
